#!/usr/bin/perl

use lib "./modules";

use IO::Socket;				# For socket operations
use Getopt::Std;			# To parse the input
use arb_scan;				# Main module for arb-scan
use check_service;			# Module with banner checks
use network;				# Socket stuff :)


getopts('hrl:s:i:t:c:', \%opt) || usage();

# Parse options
if (defined($opt{'h'})) {
  usage();
  exit(0);
}
if (defined($opt{'c'})) {
  do "$opt{'c'}" || die print "Error: Can't read config file($opt{'c'}) because: $!\n";
}
else {
  do "./config/arb-scan.conf" || die print "Error: Can't read config file(./config/arb-scan.conf) because : $!\n";
}
if (defined($opt{'t'})) {
  if ($opt{'t'} !~ /daytime|ftp|ssh|smtp|domain|finger|http|pop2|pop3|nntp|imap2|imap3|snpp|none|all/i) {
    usage();
    exit(1);
  }
  else {
    $service = $opt{'t'};
  }
}
else {
   usage();
   exit(1);
}
if (defined($opt{'s'})) {
  $dest = $opt{'s'};
}
elsif (defined($opt{'r'})) {
  if (defined($opt{'l'})) {
    if (!($opt{'l'} <= 0)) {
      $loop_count = $opt{'l'};
    }
    else {
      usage();
      exit(1);
    }
  }
  else {
    $loop_count = 1;
    $dest = rand_ip();
  }
}
elsif (defined($opt{'i'})) {
  $file = $opt{'i'};
}
else {
  usage();
  exit(1);
}

if ($SHOWVERSION == 1) {
  header();
}

if (($SCANTYPE eq "s") || ($SCANTYPE eq "u")) {
  if ($< != 0) {
    print "The specified port scan type need root.\n";
    exit(1); 
  }
}

if (defined($file)) {
  open(FILE, "$file") || die print "Error: Can't open ip-file($file) because: $!\n";  
  @hosts = <FILE>;
  close(FILE);

  print "- found ", scalar(@hosts), " hosts in $file\n";
  foreach $dest (@hosts) {
    chomp($dest);
    if ($COUNT == 1) {
      $i++;
      print "- next host is number : $i\n";
    }
    select_service($dest, $service);
    if ($SHOWOS == 1) {
      system("scripts/./grep-os.sh", $dest);
    }
    if ($SHOWUPTIME == 1) {
      system("scripts/./grep-uptime.sh", $dest);
    }
  }  
} 
elsif (defined($loop_count)) {
  for ($i = 1; $i <= $loop_count; $i++) {
    $dest = rand_ip();
    if ($COUNT == 1) {
      print "- next host is number : $i\n";
    }   
    select_service($dest, $service);
    if ($SHOWOS == 1) {
      system("scripts/./grep-os.sh", $dest);
    }
    if ($SHOWUPTIME == 1) {
      system("scripts/./grep-uptime.sh", $dest);
    }
  }
}
else {
  select_service($dest, $service);
  if ($SHOWOS == 1) {
    system("scripts/./grep-os.sh", $dest);
  }
  if ($SHOWUPTIME == 1) {
    system("scripts/./grep-uptime.sh", $dest);
  }
}

# by arbon(arbon@gmx.de)
